'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-d337cd8a.js');
const helpers = require('./helpers-fc4016d2.js');

const icTabGroupCss = ":host{display:block;margin-bottom:var(--ic-space-md);border-bottom:var(--ic-space-1px) solid var(--ic-tab-bottom-border)}:host(.ic-tab-group-monochrome){border-bottom:var(--ic-space-1px) solid\n    var(--ic-tab-bottom-border-monochrome)}:host(.ic-tab-group-inline){margin-bottom:0;border-bottom:none}.tabs-container{display:flex;flex-direction:row}.tabs-container::-webkit-scrollbar{display:none}:host ic-horizontal-scroll{--splitter-color:var(--ic-tab-divider)}:host(.ic-tab-group-monochrome) ic-horizontal-scroll{--splitter-color:var(--ic-tab-divider-monochrome)}";
const IcTabGroupStyle0 = icTabGroupCss;

const TabGroup = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        /**
         * If `true`, the tabs and tab panels will be positioned separately.
         */
        this.inline = false;
        /** @internal Determines whether black variant of the tabs should be displayed. */
        this.monochrome = false;
        /** @internal Determines whether the light or dark variant of the tabs should be displayed. */
        this.theme = "inherit";
    }
    componentDidLoad() {
        helpers.onComponentRequiredPropUndefined([{ prop: this.label, propName: "label" }], "Tab Group");
    }
    render() {
        const { inline, theme, label, monochrome } = this;
        return (index.h(index.Host, { key: '843cb9e2c3bf88635d7721ce01d0fbcac8c0f774', role: "tablist", "aria-label": label, class: {
                ["ic-tab-group-inline"]: !!inline,
                [`ic-theme-${theme}`]: theme !== "inherit",
                ["ic-tab-group-monochrome"]: !!monochrome,
            } }, index.h("ic-horizontal-scroll", { key: '3e65658082dfa15c4249b942a4231402b9b20856', theme: theme, "focus-trigger": "tabFocus", monochrome: monochrome }, index.h("div", { key: '579c86d070a566e752c102195b8d13de7bdd0ac9', class: "tabs-container" }, index.h("slot", { key: 'c5d14fa4615b470d8aa01b567667768427f20e50' })))));
    }
    static get delegatesFocus() { return true; }
};
TabGroup.style = IcTabGroupStyle0;

exports.ic_tab_group = TabGroup;

//# sourceMappingURL=ic-tab-group.cjs.entry.js.map