import { proxyCustomElement, HTMLElement, createEvent, h, Fragment, Host } from '@stencil/core/internal/client';
import { c as checkIcon } from './check-icon.js';
import { J as isMacDevice, o as onComponentRequiredPropUndefined, K as getOptionsWithoutGroupTitlesCount } from './helpers.js';
import { d as defineCustomElement$4 } from './ic-button2.js';
import { d as defineCustomElement$3 } from './ic-loading-indicator2.js';
import { c as createPopper, d as defineCustomElement$2 } from './ic-tooltip2.js';
import { d as defineCustomElement$1 } from './ic-typography2.js';

const icMenuCss = "html.sc-ic-menu{line-height:1.15;-webkit-text-size-adjust:100%}body.sc-ic-menu{margin:0}main.sc-ic-menu{display:block}h1.sc-ic-menu{font-size:2em;margin:0.67em 0}hr.sc-ic-menu{box-sizing:content-box;height:0;overflow:visible}pre.sc-ic-menu{font-family:monospace, monospace;font-size:1em}a.sc-ic-menu{background-color:transparent}abbr[title].sc-ic-menu{border-bottom:none;text-decoration:underline;-webkit-text-decoration:underline dotted;text-decoration:underline dotted}b.sc-ic-menu,strong.sc-ic-menu{font-weight:bolder}code.sc-ic-menu,kbd.sc-ic-menu,samp.sc-ic-menu{font-family:monospace, monospace;font-size:1em}small.sc-ic-menu{font-size:80%}sub.sc-ic-menu,sup.sc-ic-menu{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub.sc-ic-menu{bottom:-0.25em}sup.sc-ic-menu{top:-0.5em}img.sc-ic-menu{border-style:none}button.sc-ic-menu,input.sc-ic-menu,optgroup.sc-ic-menu,select.sc-ic-menu,textarea.sc-ic-menu{font-family:inherit;font-size:100%;line-height:1.15;margin:0}button.sc-ic-menu,input.sc-ic-menu{overflow:visible}button.sc-ic-menu,select.sc-ic-menu{text-transform:none}button.sc-ic-menu,[type=\"button\"].sc-ic-menu,[type=\"reset\"].sc-ic-menu,[type=\"submit\"].sc-ic-menu{-webkit-appearance:button}button.sc-ic-menu::-moz-focus-inner,[type=\"button\"].sc-ic-menu::-moz-focus-inner,[type=\"reset\"].sc-ic-menu::-moz-focus-inner,[type=\"submit\"].sc-ic-menu::-moz-focus-inner{border-style:none;padding:0}button.sc-ic-menu:-moz-focusring,[type=\"button\"].sc-ic-menu:-moz-focusring,[type=\"reset\"].sc-ic-menu:-moz-focusring,[type=\"submit\"].sc-ic-menu:-moz-focusring{outline:1px dotted ButtonText}fieldset.sc-ic-menu{padding:0.35em 0.75em 0.625em}legend.sc-ic-menu{box-sizing:border-box;color:inherit;display:table;max-width:100%;padding:0;white-space:normal}progress.sc-ic-menu{vertical-align:baseline}textarea.sc-ic-menu{overflow:auto}[type=\"checkbox\"].sc-ic-menu,[type=\"radio\"].sc-ic-menu{box-sizing:border-box;padding:0}[type=\"number\"].sc-ic-menu::-webkit-inner-spin-button,[type=\"number\"].sc-ic-menu::-webkit-outer-spin-button{height:auto}[type=\"search\"].sc-ic-menu{-webkit-appearance:textfield;outline-offset:-2px}[type=\"search\"].sc-ic-menu::-webkit-search-decoration{-webkit-appearance:none}.sc-ic-menu::-webkit-file-upload-button{-webkit-appearance:button;font:inherit}details.sc-ic-menu{display:block}summary.sc-ic-menu{display:list-item}template.sc-ic-menu{display:none}[hidden].sc-ic-menu{display:none}html.sc-ic-menu,body.sc-ic-menu,div.sc-ic-menu,span.sc-ic-menu,applet.sc-ic-menu,object.sc-ic-menu,iframe.sc-ic-menu,h1.sc-ic-menu,h2.sc-ic-menu,h3.sc-ic-menu,h4.sc-ic-menu,h5.sc-ic-menu,h6.sc-ic-menu,p.sc-ic-menu,blockquote.sc-ic-menu,pre.sc-ic-menu,a.sc-ic-menu,abbr.sc-ic-menu,acronym.sc-ic-menu,address.sc-ic-menu,big.sc-ic-menu,cite.sc-ic-menu,code.sc-ic-menu,del.sc-ic-menu,dfn.sc-ic-menu,em.sc-ic-menu,img.sc-ic-menu,ins.sc-ic-menu,kbd.sc-ic-menu,q.sc-ic-menu,s.sc-ic-menu,samp.sc-ic-menu,small.sc-ic-menu,strike.sc-ic-menu,strong.sc-ic-menu,sub.sc-ic-menu,sup.sc-ic-menu,tt.sc-ic-menu,var.sc-ic-menu,b.sc-ic-menu,u.sc-ic-menu,i.sc-ic-menu,center.sc-ic-menu,dl.sc-ic-menu,dt.sc-ic-menu,dd.sc-ic-menu,ol.sc-ic-menu,ul.sc-ic-menu,li.sc-ic-menu,fieldset.sc-ic-menu,form.sc-ic-menu,label.sc-ic-menu,legend.sc-ic-menu,table.sc-ic-menu,caption.sc-ic-menu,tbody.sc-ic-menu,tfoot.sc-ic-menu,thead.sc-ic-menu,tr.sc-ic-menu,th.sc-ic-menu,td.sc-ic-menu,article.sc-ic-menu,aside.sc-ic-menu,canvas.sc-ic-menu,details.sc-ic-menu,embed.sc-ic-menu,figure.sc-ic-menu,figcaption.sc-ic-menu,footer.sc-ic-menu,header.sc-ic-menu,hgroup.sc-ic-menu,menu.sc-ic-menu,nav.sc-ic-menu,output.sc-ic-menu,ruby.sc-ic-menu,section.sc-ic-menu,summary.sc-ic-menu,time.sc-ic-menu,mark.sc-ic-menu,audio.sc-ic-menu,video.sc-ic-menu{margin:0;padding:0;border:0;font-size:100%;font-style:inherit;vertical-align:baseline}@media (prefers-reduced-motion: no-preference){.ic-menu-open.sc-ic-menu-h .menu.sc-ic-menu{transition:max-height var(--ic-transition-duration-slow)}}.sc-ic-menu-h{max-height:0;width:var(--menu-width, var(--input-width, 20rem));color:var(--menu-item-text-color, var(--ic-menu-list-option-text-color));--ic-typography-color:var(\n    --menu-item-text-color,\n    var(--ic-menu-list-option-text-color)\n  );background-color:var(\n    --menu-bg-color,\n    var(--ic-menu-list-option-background-color)\n  );position:relative;z-index:var(--ic-z-index-menu);box-sizing:border-box;box-shadow:var(--ic-elevation-overlay);border-radius:var(--ic-border-radius)}.ic-menu-open.sc-ic-menu-h:not(.ic-menu-no-focus):focus-within{box-shadow:var(--ic-border-focus);outline:var(--ic-hc-focus-outline)}.ic-select-select-all-focused.sc-ic-menu-h{box-shadow:var(--ic-elevation-overlay) !important}#retry-button.sc-ic-menu::part(button){height:var(--ic-space-lg)}.small.sc-ic-menu #retry-button.sc-ic-menu::part(button){height:var(--ic-space-md)}.on-dialog.sc-ic-menu-h{inset:auto !important}.menu.sc-ic-menu{text-decoration:none;list-style-type:none;border-radius:1px;background-color:var(\n    --menu-bg-color,\n    var(--ic-menu-list-option-background-color)\n  );visibility:hidden;max-height:0;overflow-y:hidden}.menu.sc-ic-menu:has(+.option-bar).sc-ic-menu{border-radius:0 0 1px 1px}.menu-scroll.sc-ic-menu{overflow-y:auto}.menu.sc-ic-menu:focus-visible{outline:none}.ic-menu-open.sc-ic-menu-h{max-height:none;display:flex;flex-direction:column-reverse;border:var(--ic-border-width) solid\n    var(--menu-border-color, var(--ic-menu-border-color));transition:box-shadow var(--ic-easing-transition-fast)}.ic-menu-open.sc-ic-menu-h .menu.sc-ic-menu{visibility:visible;max-height:calc(var(--ic-space-xl) * 10 + var(--ic-space-xxxs))}.ic-menu-open.sc-ic-menu-h .option-bar.sc-ic-menu{visibility:visible}.ic-menu-open.sc-ic-menu-h .select-all-button.sc-ic-menu{display:block}.ic-menu-full-width.sc-ic-menu-h{width:100%}.option.sc-ic-menu{padding:var(--ic-space-xs) calc(var(--ic-space-xs) - var(--ic-space-1px));cursor:pointer;display:flex;align-items:center}.loading-option.sc-ic-menu p.sc-ic-menu{margin-bottom:0 !important}.option.sc-ic-menu:not(.loading-option){justify-content:space-between}.ic-menu-small.sc-ic-menu-h .option.sc-ic-menu{padding:var(--ic-space-xxs) calc(var(--ic-space-xs) - var(--ic-space-1px))}.ic-menu-large.sc-ic-menu-h .option.sc-ic-menu{padding:var(--ic-space-sm) calc(var(--ic-space-xs) - var(--ic-space-1px))}.option.sc-ic-menu:last-child{border-radius:0 0 1px 1px}.sc-ic-menu:not(.menu:has(+.option-bar)).sc-ic-menu .option.sc-ic-menu:first-child{border-radius:1px 1px 0 0}.option.sc-ic-menu:not(.disabled-option):hover{background-color:var(--ic-menu-list-option-hover-background-color)}.option.sc-ic-menu:not(.disabled-option):active{background-color:var(--ic-menu-list-option-pressed-background-color)}.option.sc-ic-menu:focus-visible{outline:var(--ic-hc-focus-outline)}.option.sc-ic-menu:not(.disabled-option) .option-description.sc-ic-menu{--ic-typography-color:var(\n    --menu-item-desc-text-color,\n    var(--ic-menu-list-option-description-text-color)\n  )}.option.sc-ic-menu .option-label.sc-ic-menu{display:flex;flex-direction:row;align-items:top}.option.sc-ic-menu .option-label.sc-ic-menu ic-typography.sc-ic-menu{max-width:100%;word-wrap:break-word}.option.sc-ic-menu .option-element.sc-ic-menu{margin-top:var(--ic-space-xxs)}.option.sc-ic-menu .option-icon.sc-ic-menu{height:var(--ic-space-md);width:var(--ic-space-md);margin-top:var(--ic-space-xxs);margin-right:var(--ic-space-xxxs)}.option-text-container.sc-ic-menu{pointer-events:none;width:100%}.option-text-container.show-check-icon.sc-ic-menu{width:calc(var(--ic-space-lg) * 10 + var(--ic-space-xl))}.option.loading-option.sc-ic-menu .option-text-container.sc-ic-menu{margin-left:calc(var(--ic-space-xs) + var(--ic-space-xxxs));color:var(--ic-menu-loading-list-option-text-color);--ic-typography-color:var(--ic-menu-loading-list-option-text-color)}.error-icon-svg.sc-ic-menu{height:var(--ic-space-md);width:var(--ic-space-md);fill:var(--ic-atoms-status-icon-error);align-self:center;display:flex;margin-right:calc(var(--ic-space-xxs) * 1.2)}.loading-error-info.sc-ic-menu{display:flex}.check-icon.sc-ic-menu{height:var(--ic-space-lg);min-width:var(--ic-space-lg);width:var(--ic-space-lg);margin-left:var(--ic-space-xs);pointer-events:none}.focused-option.sc-ic-menu .check-icon.sc-ic-menu *.sc-ic-menu{fill:currentcolor}.option-group-title.sc-ic-menu{padding:var(--ic-space-lg) calc(var(--ic-space-xs) - var(--ic-space-1px))\n    var(--ic-space-xs);--ic-typography-color:var(--ic-menu-option-group-label-text-color)}.ic-menu-small.sc-ic-menu-h .option-group-title.sc-ic-menu{padding:var(--ic-space-sm) calc(var(--ic-space-xs) - var(--ic-space-1px))\n    var(--ic-space-xxs)}.last-recommended-option.sc-ic-menu{border-bottom:var(--ic-menu-last-recommended-option-border)}.disabled-option.sc-ic-menu{color:var(--ic-atoms-list-option-text-disabled-light);--ic-typography-color:var(--ic-atoms-list-option-text-disabled-light);cursor:default;pointer-events:none}.focused-option.sc-ic-menu,.focused-option.sc-ic-menu .option-description.sc-ic-menu{background-color:var(--ic-color-focus-inner) !important;color:var(--ic-atoms-list-option-text-focused-light) !important;--ic-typography-color:var(\n    --ic-atoms-list-option-text-focused-light\n  ) !important}.no-results.sc-ic-menu-h li.sc-ic-menu{cursor:no-drop}.no-results.sc-ic-menu-h li.sc-ic-menu:hover{background-color:transparent}.option-bar.sc-ic-menu{padding:var(--ic-space-xxs) var(--ic-space-xs);display:flex;align-items:center;justify-content:space-between;background-color:var(--ic-menu-option-bar-background-color);visibility:hidden;border-bottom:var(--ic-border-width) solid\n    var(--ic-menu-option-bar-divider-color);border-radius:1px 1px 0 0}.option-bar.sc-ic-menu p.sc-ic-menu{margin-bottom:0 !important}.ic-menu-large.sc-ic-menu-h .option-bar.sc-ic-menu{padding:var(--ic-space-xs)}.select-all-button.sc-ic-menu{display:none}.select-all-button.sc-ic-menu:focus{z-index:calc(var(--ic-z-index-menu) + 1)}@media (forced-colors: active){.focused-option.sc-ic-menu:focus{outline:none;border:0.125rem solid transparent}.disabled-option.sc-ic-menu{color:GrayText;--ic-typography-color:GrayText}}";
const IcMenuStyle0 = icMenuCss;

const Menu = /*@__PURE__*/ proxyCustomElement(class Menu extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.icClear = createEvent(this, "icClear", 7);
        this.menuKeyPress = createEvent(this, "menuKeyPress", 7);
        this.menuOptionId = createEvent(this, "menuOptionId", 7);
        this.menuOptionSelect = createEvent(this, "menuOptionSelect", 7);
        this.menuOptionSelectAll = createEvent(this, "menuOptionSelectAll", 7);
        this.menuStateChange = createEvent(this, "menuStateChange", 7);
        this.retryButtonClicked = createEvent(this, "retryButtonClicked", 7);
        this.timeoutBlur = createEvent(this, "timeoutBlur", 7);
        this.ungroupedOptionsSet = createEvent(this, "ungroupedOptionsSet", 7);
        this.ACTIVE_DESCENDANT = "aria-activedescendant";
        this.CLEAR_BUTTON_ID = "clear-button";
        this.SEARCH_BAR_TAG = "IC-SEARCH-BAR";
        this.disabledOptionSelected = false;
        this.hasPreviouslyBlurred = false;
        this.hasTimedOut = false;
        this.isLoading = false;
        this.isMultiSelect = false;
        this.isSearchBar = false;
        this.isSearchableSelect = false;
        this.lastOptionSelected = null; // Index of last option selected
        this.lastOptionFocused = null; // Index of last option focused
        this.multiOptionClicked = null;
        this.preventClickOpen = false; // Prevents menu re-opening immediately after it is closed on blur when clicking input.
        this.preventMenuFocus = false; // (When multiple) ensures focus moves straight to select all button from menu.
        this.shiftPressed = false;
        this.ungroupedOptions = [];
        this.focusFromSearchKeypress = false;
        this.initialOptionsListRender = false;
        this.keyboardNav = false;
        this.preventIncorrectTabOrder = false;
        /**
         * Determines whether options manually set as values (by pressing 'Enter') when they receive focus using keyboard navigation.
         */
        this.activationType = "automatic";
        /**
         * @internal If `true`, autofocus will be applied on selected item when menu is open.
         */
        this.autofocusOnSelected = true;
        /**
         *  If `true`, the menu will close when an option is selected.
         */
        this.closeOnSelect = true;
        /**
         *  If `true`, the menu will fill the width of the container.
         */
        this.fullWidth = false;
        /**
         * The custom name for the label field for IcMenuOption.
         */
        this.labelField = "label";
        /**
         * Specify the mode search bar uses to search. `navigation` allows for quick lookups of a set of values, `query` allows for more general searches.
         */
        this.searchMode = "navigation";
        /**
         * @internal If `true`, the icOptionSelect event will be fired on enter instead of ArrowUp and ArrowDown.
         */
        this.selectOnEnter = false;
        /**
         * The size of the menu.
         */
        this.size = "medium";
        /**
         * The custom name for the value field for IcMenuOption.
         */
        this.valueField = "value";
        this.handleClearListener = () => {
            this.optionHighlighted = "";
        };
        this.handleSubmitSearch = () => {
            const highlightedOptionIndex = this.options.findIndex((option) => option[this.valueField] === this.optionHighlighted);
            this.setInputValue(highlightedOptionIndex);
        };
        this.handleMenuChange = (open, focusInput) => {
            var _a;
            this.menuStateChange.emit({ open, focusInput });
            if (!open) {
                if (focusInput !== false) {
                    (_a = this.inputEl) === null || _a === void 0 ? void 0 : _a.focus();
                    this.preventClickOpen = false;
                }
                // Reset optionHighlighted so previously highlighted option doesn't get reselected when Enter pressed
                if (this.isMultiSelect) {
                    this.optionHighlighted = undefined;
                    this.multiOptionClicked = null;
                }
            }
        };
        this.setNextOptionValue = (selectedOptionIndex) => {
            if (this.ungroupedOptions[selectedOptionIndex + 1]) {
                this.menuOptionSelect.emit({
                    value: this.ungroupedOptions[selectedOptionIndex + 1][this.valueField],
                    optionId: this.getOptionId(this.ungroupedOptions[selectedOptionIndex + 1][this.valueField]),
                });
            }
            else {
                this.menuOptionSelect.emit({
                    value: this.ungroupedOptions[0][this.valueField],
                    optionId: this.getOptionId(this.ungroupedOptions[0][this.valueField]),
                });
            }
        };
        this.setPreviousOptionValue = (selectedOptionIndex) => {
            if (this.ungroupedOptions[selectedOptionIndex - 1]) {
                this.menuOptionSelect.emit({
                    value: this.ungroupedOptions[selectedOptionIndex - 1][this.valueField],
                    optionId: this.getOptionId(this.ungroupedOptions[selectedOptionIndex - 1][this.valueField]),
                });
            }
            else {
                this.menuOptionSelect.emit({
                    value: this.ungroupedOptions[this.ungroupedOptions.length - 1][this.valueField],
                    optionId: this.getOptionId(this.ungroupedOptions[this.ungroupedOptions.length - 1][this.valueField]),
                });
            }
        };
        this.getParentEl = (parent) => {
            if (parent.tagName === this.SEARCH_BAR_TAG) {
                this.isSearchBar = true;
            }
            else if (parent.tagName === "IC-SELECT") {
                if (parent.getAttribute("searchable") !== null &&
                    parent.getAttribute("searchable") !== undefined) {
                    this.isSearchableSelect = true;
                }
                else if (parent.getAttribute("multiple") !== null &&
                    parent.getAttribute("multiple") !== undefined) {
                    this.isMultiSelect = true;
                }
            }
        };
        // Open menu when up or down arrow keys are pressed
        this.arrowBehaviour = (event) => {
            event.preventDefault();
            this.handleMenuChange(true);
        };
        this.getMenuOptions = () => this.isSearchBar ? this.options : this.ungroupedOptions;
        // Set option that is focused and so should show focus state
        this.setHighlightedOption = (highlightedIndex) => {
            const menuOptions = this.getMenuOptions();
            menuOptions[highlightedIndex] &&
                !menuOptions[highlightedIndex].timedOut &&
                (this.optionHighlighted =
                    menuOptions[highlightedIndex][this.valueField] || undefined);
        };
        // Determines keyboard behaviour when selection is automatic
        // (i.e. you don't have to press Enter select an option - just focus on it)
        // and menu is closed
        this.autoSetInputValueKeyboardOpen = (event) => {
            const selectedOptionIndex = this.ungroupedOptions.findIndex((option) => option[this.valueField] === this.value);
            this.keyboardNav = false;
            switch (event.key) {
                case "ArrowDown":
                    this.keyboardNav = true;
                    this.arrowBehaviour(event);
                    this.setNextOptionValue(selectedOptionIndex);
                    break;
                case "ArrowUp":
                    this.keyboardNav = true;
                    this.arrowBehaviour(event);
                    this.setPreviousOptionValue(selectedOptionIndex);
                    break;
                case " ":
                case "Enter":
                    if (event.target.id !== this.CLEAR_BUTTON_ID) {
                        this.handleMenuChange(true);
                    }
                    break;
            }
        };
        this.selectHighlightedOption = (options, highlightedOptionIndex) => {
            if (!this.isLoading && !this.hasTimedOut) {
                this.keyboardNav = true;
            }
            const isOpen = this.isSearchBar || this.isSearchableSelect || this.open;
            if (isOpen) {
                if (highlightedOptionIndex >= 0) {
                    if (options[highlightedOptionIndex] !== undefined) {
                        if (this.isSearchBar &&
                            options[highlightedOptionIndex].disabled === true) {
                            this.disabledOptionSelected = true;
                        }
                        else {
                            this.setInputValue(highlightedOptionIndex);
                        }
                    }
                }
                else {
                    this.setInputValue(highlightedOptionIndex);
                }
            }
            else {
                this.handleMenuChange(true);
            }
        };
        // Check if option is selected based on the index of the option
        this.isOptionSelected = (index) => {
            const menuOptions = this.getMenuOptions();
            return this.value
                ? this.value.includes(menuOptions[index][this.valueField])
                : false;
        };
        // Deselect currently selected options when shift pressed, but keep certain options selected
        this.deselectSelectedOptions = (optionsToKeepSelected) => {
            const menuOptions = this.getMenuOptions();
            if (this.value) {
                const selectedOptionIndexes = this.value.map((value) => {
                    return menuOptions.findIndex((option) => option[this.valueField] === value);
                });
                // Call setInputValue (which toggles the selected state) on options that need to be deselected
                selectedOptionIndexes.forEach((index) => !optionsToKeepSelected.includes(index) && this.setInputValue(index));
            }
        };
        // Determines keyboard behaviour when selection is manual (i.e. when you have to press Enter to select an option)
        this.manualSetInputValueKeyboardOpen = (event) => {
            const menuOptions = this.getMenuOptions();
            // For preventing focus disappearing on currently focused option when Shift / Cmd / Ctrl pressed
            // (i.e. when user is likely in the middle of executing a keyboard combination to select options)
            const isKeyboardCombination = event.shiftKey || event.metaKey || event.ctrlKey;
            const highlightedOptionIndex = this.getOptionHighlightedIndex();
            const clickedMultiOptionIndex = menuOptions.findIndex((option) => option[this.valueField] === this.multiOptionClicked);
            const getOptionId = (index) => { var _a; return (_a = Array.from(this.host.querySelectorAll("li"))[index]) === null || _a === void 0 ? void 0 : _a.id; };
            // Space press should be equivalent to Enter when multi-select
            if (event.key === " " && this.isMultiSelect) {
                this.handleOptionSelect(event, highlightedOptionIndex);
            }
            else {
                switch (event.key) {
                    case "ArrowDown":
                        this.keyboardNav = true;
                        this.arrowBehaviour(event);
                        if (this.multiOptionClicked) {
                            // Set focus to option last clicked
                            // Prevents it resetting to the top of the menu when user switches to using keyboard
                            this.setHighlightedOption(clickedMultiOptionIndex);
                            this.multiOptionClicked = null;
                        }
                        else {
                            this.handleSingleShiftSelect(event, highlightedOptionIndex, menuOptions);
                            if (highlightedOptionIndex < menuOptions.length - 1) {
                                this.setHighlightedOption(highlightedOptionIndex + 1);
                                this.menuOptionId.emit({
                                    optionId: getOptionId(highlightedOptionIndex + 1),
                                });
                                this.handleSingleShiftSelect(event, highlightedOptionIndex + 1, menuOptions);
                            }
                            else {
                                this.setHighlightedOption(0);
                                this.menuOptionId.emit({
                                    optionId: getOptionId(0),
                                });
                                this.handleSingleShiftSelect(event, 0, menuOptions);
                            }
                            // Deselect currently selected options if arrow was pressed for first time after shift is held
                            if (this.isMultiSelect && this.shiftPressed) {
                                this.deselectSelectedOptions([
                                    highlightedOptionIndex,
                                    this.getOptionHighlightedIndex(),
                                ]);
                                this.shiftPressed = false;
                            }
                        }
                        this.lastOptionFocused = this.getOptionHighlightedIndex();
                        this.preventIncorrectTabOrder = false;
                        this.focusFromSearchKeypress = false;
                        break;
                    case "ArrowUp":
                        this.keyboardNav = true;
                        this.arrowBehaviour(event);
                        if (this.multiOptionClicked) {
                            // Set focus to option last clicked
                            // Prevents it resetting to the bottom of the menu when user switches to using keyboard
                            this.setHighlightedOption(clickedMultiOptionIndex);
                            this.multiOptionClicked = null;
                        }
                        else {
                            this.handleSingleShiftSelect(event, highlightedOptionIndex, menuOptions);
                            if (highlightedOptionIndex <= 0 ||
                                highlightedOptionIndex > menuOptions.length + 1) {
                                this.setHighlightedOption(menuOptions.length - 1);
                                this.menuOptionId.emit({
                                    optionId: getOptionId(menuOptions.length - 1),
                                });
                                this.handleSingleShiftSelect(event, menuOptions.length - 1, menuOptions);
                            }
                            else {
                                this.setHighlightedOption(highlightedOptionIndex - 1);
                                this.menuOptionId.emit({
                                    optionId: getOptionId(highlightedOptionIndex - 1),
                                });
                                this.handleSingleShiftSelect(event, highlightedOptionIndex - 1, menuOptions);
                            }
                            // Deselect currently selected options if arrow was pressed for first time after shift is held
                            if (this.isMultiSelect && this.shiftPressed) {
                                this.deselectSelectedOptions([
                                    highlightedOptionIndex,
                                    this.getOptionHighlightedIndex(),
                                ]);
                                this.shiftPressed = false;
                            }
                        }
                        this.lastOptionFocused = this.getOptionHighlightedIndex();
                        this.preventIncorrectTabOrder = false;
                        this.focusFromSearchKeypress = false;
                        break;
                    case "Home": {
                        const startOptionIndex = 0;
                        this.keyboardNav = true;
                        event.preventDefault();
                        this.arrowBehaviour(event);
                        this.setHighlightedOption(startOptionIndex);
                        this.menuOptionId.emit({
                            optionId: getOptionId(startOptionIndex),
                        });
                        if (event.shiftKey && event.ctrlKey) {
                            this.handleMultipleShiftSelect(startOptionIndex);
                        }
                        this.lastOptionFocused = startOptionIndex;
                        this.lastOptionSelected = startOptionIndex;
                        break;
                    }
                    case "End": {
                        const endOptionIndex = menuOptions.length - 1;
                        this.keyboardNav = true;
                        event.preventDefault();
                        this.arrowBehaviour(event);
                        this.setHighlightedOption(endOptionIndex);
                        this.menuOptionId.emit({
                            optionId: getOptionId(endOptionIndex),
                        });
                        if (event.shiftKey && event.ctrlKey) {
                            this.handleMultipleShiftSelect(endOptionIndex);
                        }
                        this.lastOptionFocused = endOptionIndex;
                        this.lastOptionSelected = endOptionIndex;
                        break;
                    }
                    case " ":
                        if (!isKeyboardCombination) {
                            this.keyboardNav = false;
                        }
                        if (this.isSearchBar || this.isSearchableSelect) {
                            break;
                        }
                        else {
                            if (event.target.id !== this.CLEAR_BUTTON_ID) {
                                this.handleMenuChange(true);
                            }
                        }
                        break;
                    case "Enter":
                        event.preventDefault();
                        if (!isKeyboardCombination) {
                            this.keyboardNav = false;
                        }
                        this.handleOptionSelect(event, highlightedOptionIndex);
                        break;
                    case "Escape":
                        if (this.open) {
                            event.stopImmediatePropagation();
                        }
                        this.handleMenuChange(false);
                        this.menuOptionId.emit({ optionId: undefined });
                        break;
                    case "a":
                        // Checks if Cmd (meta) key is pressed if Mac device (while excluding meta key on Windows)
                        // Otherwise, if a different OS, checks Ctrl key
                        if ((isMacDevice() && event.metaKey) ||
                            (!isMacDevice() && event.ctrlKey)) {
                            this.emitSelectAllEvents();
                            this.lastOptionFocused = null;
                            this.lastOptionSelected = null;
                        }
                        break;
                    case "Shift":
                    case "Tab":
                        if (event.key === "Shift") {
                            this.shiftPressed = true;
                        }
                        if (this.isSearchBar) {
                            this.keyboardNav = true;
                        }
                        if (this.isMultiSelect) {
                            if (this.open && !event.shiftKey && this.selectAllButton) {
                                event.preventDefault();
                                this.selectAllButton.focus(); // Move focus to select all button instead of focused option
                                this.preventMenuFocus = true;
                                this.preventClickOpen = true;
                                this.optionHighlighted = undefined; // Stop any option focus states showing when focus moved to select all button
                            }
                        }
                        else {
                            this.preventIncorrectTabOrder = true;
                        }
                        break;
                    default:
                        if (!isKeyboardCombination) {
                            this.keyboardNav = false;
                        }
                        this.focusOnSearchOrSelectInput(menuOptions, highlightedOptionIndex);
                }
            }
        };
        this.setInputValue = (highlightedOptionIndex) => {
            const menuOptions = this.getMenuOptions();
            if (menuOptions[highlightedOptionIndex] !== undefined) {
                this.menuOptionSelect.emit({
                    value: menuOptions[highlightedOptionIndex][this.valueField],
                });
                if (this.closeOnSelect) {
                    this.optionHighlighted = undefined;
                    this.menuOptionId.emit({ optionId: undefined });
                }
            }
            if (this.closeOnSelect) {
                if (!this.hasTimedOut) {
                    this.handleMenuChange(false);
                }
                else {
                    this.parentEl.setFocus();
                }
            }
        };
        this.handleOptionClick = (event) => {
            const { value, label } = event.target.dataset;
            if (this.isMultiSelect) {
                const menuOptions = this.getMenuOptions();
                const selectedOptionIndex = menuOptions.findIndex((option) => option.value === value);
                this.handleOptionSelect(event, selectedOptionIndex, true);
                this.multiOptionClicked = value || null;
            }
            else {
                this.menuOptionSelect.emit({ value, label });
                this.handleMenuChange(false);
            }
            this.optionHighlighted = undefined;
        };
        this.handleRetry = () => {
            this.retryButtonClicked.emit({ value: this.value });
        };
        this.handleRetryKeyDown = (ev) => {
            if (ev.key === "Enter" || ev.key === " ") {
                ev.preventDefault();
                this.retryButtonClicked.emit({ value: this.value, keyPressed: ev.key });
            }
        };
        this.handleBlur = (event) => {
            var _a, _b, _c, _d;
            if (event.relatedTarget !== this.inputEl) {
                if (event.relatedTarget === this.selectAllButton) {
                    (_a = this.menu) === null || _a === void 0 ? void 0 : _a.removeAttribute(this.ACTIVE_DESCENDANT);
                }
                if (!(((_b = this.menu) === null || _b === void 0 ? void 0 : _b.contains(event.relatedTarget)) ||
                    event.relatedTarget === this.selectAllButton)) {
                    this.handleMenuChange(false, this.hasPreviouslyBlurred);
                    (_c = this.menu) === null || _c === void 0 ? void 0 : _c.removeAttribute(this.ACTIVE_DESCENDANT);
                    this.lastOptionFocused = null;
                    this.lastOptionSelected = null;
                }
            }
            else {
                this.handleMenuChange(false);
                this.preventClickOpen = true;
                (_d = this.menu) === null || _d === void 0 ? void 0 : _d.removeAttribute(this.ACTIVE_DESCENDANT);
                this.lastOptionFocused = null;
                this.lastOptionSelected = null;
            }
            if (!this.isSearchBar)
                this.hasPreviouslyBlurred = !!event.relatedTarget;
        };
        this.handleMouseDown = (event) => {
            event.preventDefault();
        };
        this.handleMenuKeyDown = (event) => {
            if (this.activationType === "automatic") {
                this.autoSetValueOnMenuKeyDown(event);
            }
            else if (this.activationType === "manual" && !this.isSearchBar) {
                this.manualSetInputValueKeyboardOpen(event);
            }
        };
        this.handleMenuKeyUp = (event) => {
            if (event.key === "Tab" && event.shiftKey) {
                this.preventClickOpen = false;
            }
            if (event.key === "Enter" && this.disabledOptionSelected) {
                this.disabledOptionSelected = false;
                event.stopImmediatePropagation();
            }
            if (event.key === "Shift") {
                this.shiftPressed = false;
            }
        };
        this.handleSelectAllClick = () => {
            var _a;
            this.keyboardNav = false;
            (_a = this.menu) === null || _a === void 0 ? void 0 : _a.focus();
            this.emitSelectAllEvents();
            this.lastOptionFocused = null;
            this.lastOptionSelected = null;
        };
        this.handleSelectAllBlur = (event) => {
            var _a;
            this.host.classList.remove("ic-select-select-all-focused");
            if (!((_a = this.menu) === null || _a === void 0 ? void 0 : _a.contains(event.relatedTarget))) {
                this.handleMenuChange(false, false);
            }
        };
        this.handleSelectAllFocus = () => {
            this.host.classList.add("ic-select-select-all-focused");
            this.lastOptionFocused = null;
            this.lastOptionSelected = null;
        };
        // Fix for Safari - select all button click was causing menu to close
        this.handleSelectAllMouseDown = (event) => {
            event.preventDefault();
        };
        // When shift key is being used to select contiguous options one by one on a multi-select
        // I.e. holding shift and pressing up and down arrow keys
        this.handleSingleShiftSelect = (event, optionToSelectIndex, options) => {
            if (this.isMultiSelect &&
                event.shiftKey &&
                !this.isOptionSelected(optionToSelectIndex)) {
                this.selectHighlightedOption(options, optionToSelectIndex);
                this.lastOptionSelected = optionToSelectIndex;
            }
        };
        // When shift key is being used to select multiple options at once on a multi-select
        // I.e. holding shift when selecting another option
        this.handleMultipleShiftSelect = (lastOptionInSelection, useFocusForSelection = false, firstOptionSelected = null) => {
            this.shiftPressed = false;
            const firstOptionInSelection = firstOptionSelected === null
                ? this.getFirstOptionInSelection(useFocusForSelection)
                : firstOptionSelected;
            if (firstOptionInSelection !== null) {
                const optionsToSelect = [];
                if (firstOptionInSelection < lastOptionInSelection) {
                    for (let i = firstOptionInSelection; i < lastOptionInSelection + 1; i++) {
                        optionsToSelect.push(i);
                    }
                }
                else {
                    for (let i = firstOptionInSelection; i > lastOptionInSelection - 1; i--) {
                        optionsToSelect.push(i);
                    }
                }
                optionsToSelect.forEach((optionIndex) => !this.isOptionSelected(optionIndex) && this.setInputValue(optionIndex));
                this.deselectSelectedOptions(optionsToSelect);
            }
        };
        this.handleOptionSelect = (event, optionIndex, useFocusForSelection = false) => {
            const menuOptions = this.getMenuOptions();
            const firstOptionInSelection = this.getFirstOptionInSelection(useFocusForSelection);
            if (event.shiftKey && firstOptionInSelection !== null) {
                this.handleMultipleShiftSelect(optionIndex, useFocusForSelection, firstOptionInSelection);
            }
            else {
                this.selectHighlightedOption(menuOptions, optionIndex);
            }
            this.lastOptionFocused = optionIndex;
            this.lastOptionSelected = optionIndex;
        };
        this.getFirstOptionInSelection = (useFocusForSelection) => {
            return useFocusForSelection && this.lastOptionFocused !== null
                ? this.lastOptionFocused
                : this.lastOptionSelected !== null
                    ? this.lastOptionSelected
                    : null;
        };
        this.emitSelectAllEvents = () => {
            var _a, _b;
            // Select all if there is either no value or not all options are selected
            // 'true' means select all, 'false' means clear all
            this.menuOptionSelectAll.emit({
                select: !this.value || !(((_a = this.value) === null || _a === void 0 ? void 0 : _a.length) === this.ungroupedOptions.length),
            });
            // Emit clear event if all options are selected
            if (((_b = this.value) === null || _b === void 0 ? void 0 : _b.length) === this.ungroupedOptions.length) {
                this.icClear.emit();
            }
        };
        this.emitMenuKeyPress = (isNavKey, key) => {
            this.menuKeyPress.emit({ isNavKey: isNavKey, key: key });
        };
        // Determines keyboard behaviour when selection is automatic
        // (i.e. you don't have to press Enter select an option - just focus on it)
        // and menu is focused
        this.autoSetValueOnMenuKeyDown = (event) => {
            var _a, _b;
            event.cancelBubble = true;
            const selectedOptionIndex = this.ungroupedOptions.findIndex((option) => option[this.valueField] === this.value);
            const isSearchableSelect = !!this.inputEl && this.inputEl.tagName === "INPUT";
            this.keyboardNav = false;
            switch (event.key) {
                case " ":
                    event.preventDefault();
                    break;
                case "ArrowUp":
                    if (!this.hasTimedOut) {
                        event.preventDefault();
                        this.setPreviousOptionValue(selectedOptionIndex);
                        this.keyboardNav = true;
                    }
                    break;
                case "ArrowDown":
                    if (!this.hasTimedOut) {
                        event.preventDefault();
                        this.setNextOptionValue(selectedOptionIndex);
                        this.keyboardNav = true;
                    }
                    break;
                case "Home":
                    this.menuOptionSelect.emit({
                        value: this.ungroupedOptions[0][this.valueField],
                    });
                    this.keyboardNav = true;
                    break;
                case "End":
                    this.menuOptionSelect.emit({
                        value: this.ungroupedOptions[this.ungroupedOptions.length - 1][this.valueField],
                    });
                    this.keyboardNav = true;
                    break;
                case "Enter":
                    !this.hasTimedOut && this.handleMenuChange(false);
                    break;
                case "Escape":
                    this.handleMenuChange(false);
                    break;
                case "Backspace":
                    if (isSearchableSelect) {
                        (_a = this.inputEl) === null || _a === void 0 ? void 0 : _a.focus();
                    }
                    break;
                case "Shift":
                    break;
                default:
                    if (isSearchableSelect && event.key !== "Tab" && !this.hasTimedOut) {
                        (_b = this.inputEl) === null || _b === void 0 ? void 0 : _b.focus();
                    }
                    if (event.key.length === 1) {
                        this.keyboardNav = true;
                    }
                    break;
            }
            this.emitMenuKeyPress(this.keyboardNav, event.key);
        };
        this.getOptionId = (value) => {
            return `${this.menuId}-${value}`;
        };
        this.getOptionAriaLabel = (option, parentOption) => {
            let ariaLabel = option[this.labelField];
            if (option.description) {
                ariaLabel = `${ariaLabel}, ${option.description}`;
            }
            if (option.element) {
                ariaLabel = `${ariaLabel}, ${option.element.ariaLabel}`;
            }
            if (parentOption) {
                return `${ariaLabel}, ${parentOption[this.labelField]} group`;
            }
            else {
                return ariaLabel;
            }
        };
        this.getSortedOptions = (options) => {
            let sorted = [];
            if (options.sort) {
                sorted = options.sort((optionA, optionB) => optionA.recommended && !optionB.recommended ? -1 : 0);
            }
            return sorted;
        };
        this.getOptionHighlightedIndex = () => {
            const menuOptions = this.getMenuOptions();
            return menuOptions.findIndex((option) => option[this.valueField] === this.optionHighlighted);
        };
        this.isManualMode = this.activationType === "manual";
        this.scrollToSelected = (menu) => {
            var _a;
            const selectedOption = this.selectOnEnter
                ? this.host.querySelector(`li[data-value="${this.optionHighlighted}"]`)
                : menu.querySelector(".option[aria-selected='true']");
            if (selectedOption) {
                const elTop = selectedOption.offsetTop + selectedOption.offsetHeight;
                if (elTop > menu.scrollTop + menu.offsetHeight ||
                    elTop < menu.scrollTop + menu.offsetHeight) {
                    menu.scrollTop = selectedOption.offsetTop;
                }
                // 'aria-activedescendant' affects screen reader focus
                // https://www.w3.org/TR/2017/WD-wai-aria-practices-1.1-20170628/#kbd_focus_activedescendant
                (_a = this.menu) === null || _a === void 0 ? void 0 : _a.setAttribute(this.ACTIVE_DESCENDANT, selectedOption.id);
                selectedOption.focus();
            }
        };
        // Set 'ungroupedOptions' variable and emit its value
        // - this is all the options with disabled options and group titles removed
        this.loadUngroupedOptions = () => {
            if (this.options.length > 0 && this.options.map) {
                this.options.map((option) => {
                    if (option.children) {
                        option.children.map((option) => !option.disabled && this.ungroupedOptions.push(option));
                    }
                    else if (!option.disabled) {
                        this.ungroupedOptions.push(option);
                    }
                });
            }
            this.ungroupedOptions = this.getSortedOptions(this.ungroupedOptions);
            this.ungroupedOptionsSet.emit({ options: this.ungroupedOptions });
        };
        this.setMenuScrollbar = () => {
            var _a;
            let optionsHeight = 0;
            this.host
                .querySelectorAll(".option, .option-group-title")
                .forEach((option) => (optionsHeight += option.clientHeight));
            if (optionsHeight >= 320) {
                (_a = this.menu) === null || _a === void 0 ? void 0 : _a.classList.add("menu-scroll");
            }
        };
        this.handleTimeoutBlur = (ev) => {
            this.timeoutBlur.emit({ ev });
        };
        this.optionContent = (option, selected) => {
            var _a;
            const showCheckIcon = !!option[this.valueField] &&
                !!this.value &&
                selected &&
                ((_a = this.parentEl) === null || _a === void 0 ? void 0 : _a.tagName) !== this.SEARCH_BAR_TAG;
            return (h(Fragment, null, option.loading && h("ic-loading-indicator", { size: "icon" }), h("div", { class: {
                    "option-text-container": true,
                    "show-check-icon": showCheckIcon,
                } }, h("div", { class: "option-label" }, option.icon && (h("div", { class: "option-icon", innerHTML: option.icon, "aria-hidden": "true" })), h("ic-typography", { variant: "body", "aria-hidden": "true" }, option[this.labelField])), option.description && (h("ic-typography", { id: `${this.getOptionId(option[this.valueField])}-description`, class: "option-description", variant: "caption", "aria-hidden": "true" }, h("p", null, option.description))), option.element && (h("div", { class: "option-element", innerHTML: option.element.component, "aria-hidden": "true" }))), showCheckIcon && h("span", { class: "check-icon", innerHTML: checkIcon })));
        };
        this.displayOption = (option, selected, index, parentOption) => {
            const { open, keyboardNav, isManualMode, initialOptionsListRender, optionHighlighted, options, } = this;
            return (h("li", { id: this.getOptionId(option[this.valueField]), class: {
                    option: true,
                    "focused-option": isManualMode
                        ? (keyboardNav || initialOptionsListRender) &&
                            option[this.valueField] === optionHighlighted
                        : keyboardNav && selected,
                    "last-recommended-option": !!(option.recommended &&
                        options[index + 1] &&
                        !options[index + 1].recommended),
                    "disabled-option": !!option.disabled,
                    "loading-option": !!option.loading,
                    timeout: !!option.timedOut,
                }, role: "option", tabindex: open &&
                    (selected || option[this.valueField] === optionHighlighted) &&
                    keyboardNav
                    ? "0"
                    : "-1", "aria-label": this.getOptionAriaLabel(option, parentOption), "aria-selected": selected ? "true" : "false", "aria-disabled": option.disabled ? "true" : "false", onClick: !option.timedOut && !option.loading
                    ? this.handleOptionClick
                    : undefined, onBlur: this.handleBlur, onMouseDown: this.handleMouseDown, "data-value": option[this.valueField], "data-label": option[this.labelField] }, option.timedOut ? (h(Fragment, null, h("div", { class: "loading-error-info" }, h("svg", { class: "error-icon-svg", "aria-labelledby": "error-title", xmlns: "http://www.w3.org/2000/svg", viewBox: "0 0 24 24", fill: "#000000" }, h("title", { id: "error-title" }, "Error"), h("g", { id: "close-octagon" }, h("path", { id: "Vector", d: "M8.77 3L3.5 8.27V15.73L8.77 21H16.23L21.5 15.73V8.27L16.23 3M8.91 7L12.5 10.59L16.09 7L17.5 8.41L13.91 12L17.5 15.59L16.09 17L12.5 13.41L8.91 17L7.5 15.59L11.09 12L7.5 8.41" }))), h("ic-typography", { variant: "label" }, option[this.labelField])), h("ic-button", { size: "small", variant: "tertiary", onClick: this.handleRetry, onKeyDown: this.handleRetryKeyDown, onBlur: this.handleTimeoutBlur, id: "retry-button" }, "Retry"))) : (this.optionContent(option, selected))));
        };
    }
    watchOpenHandler() {
        if (!this.open && this.popperInstance) {
            this.popperInstance.destroy();
            this.popperInstance = null;
        }
    }
    watchOptionsHandler(newOptions) {
        this.hasTimedOut = newOptions.some((opt) => opt.timedOut);
        this.isLoading = newOptions.some((opt) => opt.loading);
        this.ungroupedOptions = [];
        this.loadUngroupedOptions();
    }
    connectedCallback() {
        if (this.parentEl)
            this.getParentEl(this.parentEl);
        if (this.isSearchBar) {
            if (this.searchMode === "navigation")
                this.setHighlightedOption(0);
            this.initialOptionsListRender = true;
        }
    }
    disconnectedCallback() {
        var _a, _b, _c;
        (_a = this.popperInstance) === null || _a === void 0 ? void 0 : _a.destroy();
        (_b = this.parentEl) === null || _b === void 0 ? void 0 : _b.removeEventListener("icClear", this.handleClearListener);
        (_c = this.parentEl) === null || _c === void 0 ? void 0 : _c.removeEventListener("icSubmitSearch", this.handleSubmitSearch);
    }
    componentWillLoad() {
        var _a, _b, _c, _d;
        this.loadUngroupedOptions();
        (_a = this.parentEl) === null || _a === void 0 ? void 0 : _a.addEventListener("icClear", this.handleClearListener);
        (_b = this.parentEl) === null || _b === void 0 ? void 0 : _b.addEventListener("icSubmitSearch", this.handleSubmitSearch);
        this.hasTimedOut = (_c = this.options) === null || _c === void 0 ? void 0 : _c.some((opt) => opt.timedOut);
        this.isLoading = (_d = this.options) === null || _d === void 0 ? void 0 : _d.some((opt) => opt.loading);
    }
    componentDidLoad() {
        if (this.isSearchBar &&
            this.parentEl.disableAutoFiltering) {
            this.focusFromSearchKeypress = true;
        }
        onComponentRequiredPropUndefined([
            { prop: this.open, propName: "open" },
            { prop: this.options, propName: "options" },
            { prop: this.menuId, propName: "menu-id" },
            { prop: this.inputLabel, propName: "input-label" },
            //NOTE: no check for value, input-el or anchor-el as otherwise get console errors on first load of select component
        ], "Menu");
    }
    componentDidUpdate() {
        const inputValueInOptions = this.options.some((option) => option[this.valueField] === this.value);
        if (this.menu &&
            this.open &&
            this.options.length !== 0 &&
            !this.preventMenuFocus) {
            if (this.value &&
                this.keyboardNav &&
                inputValueInOptions &&
                this.autofocusOnSelected &&
                !this.isSearchableSelect) {
                this.scrollToSelected(this.menu);
            }
            else if (this.selectOnEnter) {
                this.menu.focus();
            }
            else if (!!this.optionHighlighted &&
                !this.focusFromSearchKeypress &&
                !this.preventIncorrectTabOrder) {
                const highlightedEl = this.host.querySelector(`li[data-value="${this.optionHighlighted}"]`);
                if (highlightedEl) {
                    this.menu.setAttribute(this.ACTIVE_DESCENDANT, highlightedEl.id);
                    highlightedEl.focus();
                }
            }
            else if (this.inputEl && this.inputEl.tagName !== "INPUT") {
                this.menu.focus();
            }
        }
        if (this.menu && this.open && !this.value && this.selectOnEnter) {
            this.scrollToSelected(this.menu);
        }
        this.preventMenuFocus = false;
    }
    componentDidRender() {
        if (this.open && !this.popperInstance && this.anchorEl) {
            this.initPopperJs(this.anchorEl);
        }
        if (this.open && !!this.options.length) {
            this.setMenuScrollbar();
        }
    }
    /**
     * @internal If menu is opened with the mouse, emit menuStateChange custom event.
     */
    async handleClickOpen() {
        if (!this.preventClickOpen) {
            this.menuStateChange.emit({ open: !this.open });
            this.keyboardNav = false;
        }
        this.preventClickOpen = false;
    }
    /**
     * Used alongside activationType
     * If menu is opened via keyboard navigation (i.e. Enter, ArrowUp or ArrowDown), emit optionSelect custom event.
     * @param {KeyboardEvent} event The keyboard event which is available when handleKeyboardOpen is invoked.
     */
    async handleKeyboardOpen(event) {
        if (this.activationType === "automatic") {
            this.autoSetInputValueKeyboardOpen(event);
        }
        else {
            this.manualSetInputValueKeyboardOpen(event);
        }
    }
    /**
     * @internal Used to highlight the first option in the menu.
     */
    async handleSetFirstOption() {
        this.setHighlightedOption(0);
    }
    /**
     * @internal Used to initialize popperJS with an anchor element.
     * 5/12/2023: Tested with Floating UI, however, discovered inconsistent
     * boundary behaviour so sticking with PopperJS.
     */
    async initPopperJs(anchor) {
        // Placements set to "-start" to accommodate for custom menu width - menu should always be aligned to the left
        this.popperInstance = createPopper(anchor, this.host, {
            placement: "bottom-start",
            modifiers: [
                {
                    name: "offset",
                    options: {
                        offset: [0, 7],
                    },
                },
                {
                    name: "flip",
                    options: {
                        fallbackPlacements: ["top-start"],
                        rootBoundary: "viewport",
                    },
                },
            ],
        });
    }
    focusOnSearchOrSelectInput(menuOptions, highlightedOptionIndex) {
        if (!menuOptions[highlightedOptionIndex])
            return;
        if (this.isSearchBar) {
            this.parentEl.setFocus();
            if (this.searchMode === "navigation")
                this.setHighlightedOption(0);
        }
        if (this.isSearchableSelect) {
            this.parentEl.setFocus();
        }
        this.focusFromSearchKeypress = true;
    }
    render() {
        const { inputLabel, options, menuId, value, fullWidth, hasTimedOut, isLoading, size, open, inputEl, keyboardNav, parentEl, SEARCH_BAR_TAG, } = this;
        const selectAllButtonText = `${(value === null || value === void 0 ? void 0 : value.length) === this.ungroupedOptions.length ? "Clear" : "Select"} all`;
        const hasNoResults = this.host.classList.contains("no-results");
        return (h(Host, { key: '2468ababde479fb9a3c03b6148f7115589d4f8e3', class: {
                "ic-menu-full-width": !!fullWidth,
                "ic-menu-no-focus": ((inputEl === null || inputEl === void 0 ? void 0 : inputEl.tagName) === "INPUT" &&
                    (parentEl === null || parentEl === void 0 ? void 0 : parentEl.tagName) !== SEARCH_BAR_TAG) ||
                    hasTimedOut ||
                    isLoading,
                [`ic-menu-${size}`]: true,
                "ic-menu-open": open && options.length !== 0,
                "ic-menu-multiple": this.isMultiSelect,
            } }, options.length !== 0 && (h("ul", { key: '961b191dcffc99d79159937780d31ae783c6a9a0', id: menuId, class: "menu", role: "listbox", "aria-label": `${inputLabel} pop-up`, "aria-multiselectable": this.isMultiSelect ? "true" : "false", tabindex: open &&
                !keyboardNav &&
                ((inputEl === null || inputEl === void 0 ? void 0 : inputEl.tagName) !== "INPUT" ||
                    (parentEl === null || parentEl === void 0 ? void 0 : parentEl.tagName) === SEARCH_BAR_TAG)
                ? "0"
                : "-1", ref: (el) => (this.menu = el), onKeyDown: this.handleMenuKeyDown, onKeyUp: this.handleMenuKeyUp, onBlur: this.handleBlur }, this.getSortedOptions(options).map((option, index) => {
            if (option.children) {
                if (option.children.length > 0) {
                    return (h("div", null, h("ic-typography", { class: "option-group-title", role: "presentation", variant: "subtitle-small" }, h("p", null, option[this.labelField])), option.children.map((childOption) => childOption.label &&
                        this.displayOption(childOption, this.isMultiSelect
                            ? value === null || value === void 0 ? void 0 : value.includes(childOption[this.valueField])
                            : childOption[this.valueField] === value, index, option))));
                }
                else {
                    return null;
                }
            }
            else {
                // Display option only if it has a label (rather than displaying an empty space)
                return (option.label &&
                    this.displayOption(option, this.isMultiSelect
                        ? value === null || value === void 0 ? void 0 : value.includes(option[this.valueField])
                        : option[this.valueField] === value, index));
            }
        }))), options.length !== 0 &&
            this.isMultiSelect &&
            !isLoading &&
            !hasTimedOut &&
            !hasNoResults && (h("div", { key: 'f396dbf8842b3f1cdd208f8da5e98ab473266127', class: "option-bar" }, h("ic-typography", { key: 'ebccbbde58196d1c89c698cdc1af37bcc911f5fd' }, h("p", { key: '2a88b61887611ad5ebfae51066e5e1160d6241e9' }, `${value ? value.length : 0}/${getOptionsWithoutGroupTitlesCount(this.options)} selected`)), h("ic-button", { key: 'a56ebb07da92424910cf20ce14483ed2ddb2504a', class: "select-all-button", "aria-label": `${selectAllButtonText} options for ${inputLabel}`, ref: (el) => (this.selectAllButton = el), variant: "tertiary", onClick: this.handleSelectAllClick, onMouseDown: this.handleSelectAllMouseDown, onBlur: this.handleSelectAllBlur, onFocus: this.handleSelectAllFocus, size: size === "small" ? "small" : "medium" }, selectAllButtonText)))));
    }
    get host() { return this; }
    static get watchers() { return {
        "open": ["watchOpenHandler"],
        "options": ["watchOptionsHandler"]
    }; }
    static get style() { return IcMenuStyle0; }
}, [2, "ic-menu", {
        "activationType": [1, "activation-type"],
        "anchorEl": [16],
        "autofocusOnSelected": [4, "autofocus-on-selected"],
        "closeOnSelect": [4, "close-on-select"],
        "fullWidth": [4, "full-width"],
        "inputEl": [16],
        "inputLabel": [1, "input-label"],
        "labelField": [1, "label-field"],
        "menuId": [1, "menu-id"],
        "open": [516],
        "parentEl": [16],
        "searchMode": [1, "search-mode"],
        "selectOnEnter": [4, "select-on-enter"],
        "size": [1],
        "options": [16],
        "value": [1],
        "valueField": [1, "value-field"],
        "focusFromSearchKeypress": [32],
        "initialOptionsListRender": [32],
        "keyboardNav": [32],
        "optionHighlighted": [32],
        "preventIncorrectTabOrder": [32],
        "menuOptions": [32],
        "handleClickOpen": [64],
        "handleKeyboardOpen": [64],
        "handleSetFirstOption": [64],
        "initPopperJs": [64]
    }, undefined, {
        "open": ["watchOpenHandler"],
        "options": ["watchOptionsHandler"]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["ic-menu", "ic-button", "ic-loading-indicator", "ic-tooltip", "ic-typography"];
    components.forEach(tagName => { switch (tagName) {
        case "ic-menu":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, Menu);
            }
            break;
        case "ic-button":
            if (!customElements.get(tagName)) {
                defineCustomElement$4();
            }
            break;
        case "ic-loading-indicator":
            if (!customElements.get(tagName)) {
                defineCustomElement$3();
            }
            break;
        case "ic-tooltip":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
        case "ic-typography":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}

export { Menu as M, defineCustomElement as d };

//# sourceMappingURL=ic-menu2.js.map