import { IcThemeMode } from "../../utils/types";
/**
 * @slot icon - Content will be rendered to the left of the breadcrumb page title.
 */
export declare class Breadcrumb {
    private HREF_ATTR;
    private linkSlotContent;
    private slottedLinkEl;
    private slottedLinkHref;
    el: HTMLIcBreadcrumbElement;
    /**
     * If `true`, aria-current will be set on the breadcrumb.
     */
    current: boolean;
    watchCurrentHandler(): void;
    /**
     * The URL that the breadcrumb link points to.
     */
    href?: string;
    /**
     * @internal If `true`, the breadcrumb will display as black in the light theme, and white in the dark theme.
     */
    monochrome: boolean;
    /**
     * The title of the breadcrumb.
     */
    pageTitle: string;
    /**
     * @internal If `true`, back icon will be displayed.
     */
    showBackIcon: boolean;
    /**
     * @internal Sets the theme color to the dark or light theme color. "inherit" will set the color based on the system settings or ic-theme component.
     */
    theme: IcThemeMode;
    private updatedSlottedLinkFocus;
    private getSlottedLinkEl;
    componentDidLoad(): void;
    componentWillRender(): void;
    /**
     * Sets focus on the breadcrumb.
     */
    setFocus(): Promise<void>;
    private renderBackIcon;
    render(): any;
}
