import { IcInformationStatusOrEmpty, IcSizes } from "../../utils/types";
/**
 * @slot left-icon - Content will be placed to the left of the input.
 */
export declare class InputComponentContainer {
    private hostMutationObserver;
    el: HTMLIcInputComponentContainerElement;
    /**
     *  If `true`, the disabled state will be set.
     */
    disabled?: boolean;
    watchDisabledHandler(): void;
    /**
     *  If `true`, the input component container will fill the width of the container it is in.
     */
    fullWidth?: boolean;
    /**
     *  If `true`, the input component container will allow for multiple lines.
     */
    multiLine?: boolean;
    /**
     *  If `true`, the readonly state will be set.
     */
    readonly?: boolean;
    /**
     * The size of the input component container component.
     */
    size?: IcSizes;
    /**
     *  If `true`, the validation will display inline.
     */
    validationInline?: boolean;
    /**
     * The validation status of the input component container - e.g. 'error' | 'warning' | 'success'.
     */
    validationStatus?: IcInformationStatusOrEmpty;
    componentWillLoad(): void;
    componentDidLoad(): void;
    render(): any;
}
