export declare class InputLabel {
    /**
     * If `true`, the disabled state will be set.
     */
    disabled?: boolean;
    /**
     * The ID of the form element the label is bound to.
     */
    for?: string;
    /**
     * The helper text that will be displayed.
     */
    helperText: string;
    /**
     * The label will be visually hidden.
     */
    hideLabel: boolean;
    /**
     * The text content of the label.
     */
    label: string;
    /**
     * If `true`, the readonly state will be set.
     */
    readonly: boolean;
    /**
     * If `true`, the input label will require a value.
     */
    required: boolean;
    /**
     * The status of the label - e.g. 'error'.
     */
    status: "error" | "";
    /**
     * @internal If `true`, wraps label text in label tag
     */
    useLabelTag: boolean;
    componentDidLoad(): void;
    render(): any;
}
