import { EventEmitter } from "../../stencil-public-runtime";
import { IcPaginationItemType } from "./ic-pagination-item.types";
import { IcThemeMode } from "../../utils/types";
export declare class PaginationItem {
    el: HTMLIcPaginationItemElement;
    capitalizedLabel: string;
    /**
     * If `true`, the pagination item will be disabled.
     */
    disabled?: boolean;
    watchDisabledHandler(): void;
    /**
     * The label for the pagination item (applicable when simple pagination is being used).
     */
    label?: string;
    watchLabelHandler(): void;
    /**
     * If `true`, the pagination item will display as black in the light theme, and white in dark theme.
     */
    monochrome?: boolean;
    /**
     * The current page number.
     */
    page?: number;
    /**
     * If `true`, the pagination item will be selected.
     */
    selected: boolean;
    /**
     * Sets the theme color to the dark or light theme color. "inherit" will set the color based on the system settings or ic-theme component.
     */
    theme?: IcThemeMode;
    /**
     * The type of pagination item - 'page' or 'ellipsis'.
     */
    type: IcPaginationItemType;
    /**
     * @internal - Emitted when a pagination item is clicked.
     */
    paginationItemClick: EventEmitter<{
        page: number | null;
    }>;
    componentWillLoad(): void;
    private handleClick;
    render(): any;
}
