import { EventEmitter } from "../../stencil-public-runtime";
import { IcThemeMode } from "../../utils/types";
export declare class TabPanel {
    el: HTMLIcTabPanelElement;
    /**
     * @internal If `true`, the tab panel will be displayed.
     */
    active: boolean;
    /**
     * @internal Determines whether black variant of the tabs should be displayed.
     */
    monochrome?: boolean;
    /**
     * @internal The shared ID that links the panel and tab.
     */
    panelId?: string;
    /**
     * @internal The shared ID of the currently selected tab.
     */
    selectedTab?: string;
    /**
     * @internal The position of the tab panel inside the tabs array in context.
     */
    tabPosition?: number;
    /** @internal Determines whether the light or dark variant of the tabs should be displayed. */
    theme?: IcThemeMode;
    /**
     * @internal Emitted when a tab panel is dynamically created.
     */
    tabPanelCreated: EventEmitter<HTMLIcTabPanelElement>;
    /**
     * @internal Emitted when a tab panel is unmounted.
     */
    tabPanelRemoved: EventEmitter<void>;
    connectedCallback(): void;
    render(): any;
}
